// sproc.c

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

int main(int argc, char *argv[])
{
    PROCESS_INFORMATION processInfo;
    STARTUPINFO         startupInfo;
    LPTSTR              pCmd, p1, p2;
    TCHAR               szTemp[MAX_PATH];

    GetStartupInfo(&startupInfo);

    pCmd = GetCommandLine();

    // get rid of any double-quotes
    for (p1=pCmd,p2=szTemp; *p1!=0; p1++) {
        if (*p1!='"') {
            *p2 = *p1;
            p2++;
        }
    }
    *p2 = 0; // add a terminating NULL

    // skip past the module name
    p1 = szTemp + lstrlen(argv[0]);

    // get rid of any extra blanks between modulename and cmdline
    for (; *p1!=0 && *p1==' '; p1++);

    // fail if no cmdline provided
    if (*p1 == 0) {
        printf("sproc requires a command line to run\n");
        return TRUE;
    }

    printf("Executing '%s'\n", p1);

    if (!CreateProcess(NULL, p1, NULL, NULL, FALSE,
                       CREATE_SUSPENDED, NULL, NULL,
                       &startupInfo, &processInfo)) {
        printf("Error creating process <%s>\n", p1);
    }

    SetProcessAffinityMask(processInfo.hProcess, 0x1);
    ResumeThread(processInfo.hThread);
    
    CloseHandle(processInfo.hThread);
    CloseHandle(processInfo.hProcess);

    return EXIT_SUCCESS;
}
